;------------------------------------------------------------------------
;
;  Name         : MSBLOCKV.LSP  fuer TRICSY ST
;  Autor        : KST
;  Erstellt     : 30.09.1996
;  Beschreibung : Hauptprogramm fr Blockverwaltung.
;                 Unterprogramme werden geladen.
;  Funktionen   :
;
;  nderungen:
; 14.11.96 KST Aufruf der Blockverwaltung mit 'BV', nicht mit 'TS'.
; 05.03.97 KST ConvertWINtoDOS vor write-line
; 06.08.97 KST Variable 'AcadVersion' fuer ACAD-Version
; 19.10.98 KST Funkton CFG erweitert um XREF-Einstellung
; 17.08.99 KBO Klartexte durch die Funktion 'C_GT' (C_GetText) ersetzt
;              Alle Strings gehren in die Datei "TRICSY.GER" oder
;              "TRICSY.ENG" oder "TRICSY.FRA" ...
;  WICHTIG ! : Die Schluesselwoerter fuer die Hilfe wurden NICHT ueber-
;              setzt, d.h. in der englischen Hilfedatei muss hinter der
;              Raute '#' der deutsche Begriff eingetragen sein !
; 23.08.99 KBO 'C:BL' hinzugefuegt, dadurch brauchts keine extra Ueber-
;              setzung fuer die englische Version.
; 16.01.01 KST 'CFG' erweitert fuer Einstellung des Skalierfaktors
; 26.04.01 KST strInsert wird in msbv_setvar besetzt
; 16.04.02 KST Neue oberste Hierarchieebene: gewerk
; 31.03.04 KST TRICSY-ST
;
;------------------------------------------------------------------------

;----------------------- Programmvorbereitungen -------------------------
(setvar "cmdecho" 0)
(prompt (C_GT "LD_MSBLOCKV"))
(prompt ".")

; DAS BRAUCHT DOCH NICHT 2x GEWARTET ZU WERDEN !!!
(defun Start_MBV ( / fn_a fn_b fn_c )

    ; Vorbereitungen ...
    (setq lastpick "msbv")
    (msbv_setvar)
    (setq bvgrp_file (strcat bvsld_dir "\\TSMB.DIR"))    ; GRUPPEN-FILE

    ; Hier wird der Dialog ausgefuehrt
    (ms:msbv)

    ; ... und wieder klar Schiff
    (rest_setvar)
    (princ)
)

;*****************************************************************************
(prompt ".")

;***************** MSBV LADEN UND STARTEN  (international) *******************
(defun c:TRICsy ()
    (Start_MBV)
)
;*****************************************************************************
(prompt ".")

;********************* MSBV-SYSTEMVARIABLEN SETZEN ***************************
(defun msbv_setvar ()
    (setq o_cmdecho (getvar "cmdecho"))
    (setq o_expert  (getvar "expert"))
	(setq o_attreq  (getvar "attreq"))
	(setq o_pdmode  (getvar "pdmode"))
	(setq o_cecolor (getvar "cecolor"))
	(setq o_osmode  (getvar "osmode"))
    (setq o_clayer  (getvar "clayer"))
	(setq old_err   *error*)
    (setq *error*   ms_err)

    (setvar "cmdecho" 0)
    (setvar "expert"  5)
    (setvar "attreq"  0)
;    (setvar "osmode"  0)
    (command "._undo" "_g")

    (if (or (not bvprog_dir) (not bvlocal_dir) (not min_del) (not bvsld_dir))
	 (progn
        (msbv_file_def)
	 )
    )
    (if (or (not bvprog_dir) (not bvlocal_dir) (not min_del) (not bvsld_dir))
	 (progn
        (alert (C_GT "INVALID_INI_FILE"))
        (exit)
	 )
    )
    ;Variable fuer Insert-Befehl setzen
    (setq strInsert "._-insert")
)

;*****************************************************************************
(prompt ".")
;********************* PFADE ERMITTELN ***************************************
(defun msbv_file_def ( / fn z The_Ver)

    (setq fn      (strcat (C_BvCfgPath) "\\MSBV.INI"))
    (setq The_Ver (substr (getvar "acadver") 2 1))
    (if (= The_Ver "5") (progn
        (setq AcadVersion 15)
    )(progn
        (setq AcadVersion 16)
    ))

    (if fn (progn
        (setq bvprog_dir  (ReadConfigStr fn "Pathes"   "Program"))
        (setq bvlocal_dir (ReadConfigStr fn "Pathes"   "Local"))
        (setq bvsld_dir   (ReadConfigStr fn "Pathes"   "Block"))
        (setq min_del     (ReadConfigStr fn "Settings" "MinDel"))
    )(progn
        (alert (C_GT "MISSING_INI_FILE"))
        (exit)
    ))

    (setq bvhelp_file (strcat bvprog_dir  "\\MSBV.ahp"))    ; Name der Hilfe-Datei
    (setq bvdcl_file  (strcat bvprog_dir  "\\MSBV.DCL"))    ; Name der DCL-Datei
    (setq bvins_dir   bvsld_dir)                            ; Haupverz. Blcke und Dia
    (setq bvgrp_file  (strcat bvins_dir   "\\TSMB.DIR"))    ; Gruppen-File
    (setq bvcfg_file  (strcat bvlocal_dir "\\BVLAST.CFG"))  ; letzte Einstellung
)

;*****************************************************************************
(prompt ".")
;********************* ALLGEMEINE FEHLERBEHANDLUNG ***************************
; Parameter: (STR) Fehlermeldung
; Rckgabe : keine

(defun ms_err (msg / errtx)
    (if (and (/= msg "quit / exit abort") (/= msg (C_GT "S_CANCELED")) (/= msg "Tastatur-Abbruch"))
	 (progn
        (setq errpoint (strcase errpoint))
        (cond
            ((= msg (C_GT "ERR_NUM_ARGS"))
                (setq msg (strcat (substr msg 1 28) (C_GT "S_FUNCTION") errpoint))
            )
            ((= msg (C_GT "ERR_ARG_TYPE"))
                (setq msg (strcat msg (C_GT "TO_FUNCTION") errpoint))
            )
            (T (setq msg(strcat msg (C_GT "IN_FUNCTION") errpoint)))
        )
        (alert msg)
	 )
    )
    (setvar "expert"  o_expert)
    (setvar "attreq"  o_attreq)
    (setvar "pdmode"  o_pdmode)
    (setvar "cecolor" o_cecolor)
   ; (setvar "osmode"  o_osmode)
   ; (command "._undo" "_e")
    (setvar "cmdecho" o_cmdecho)
    (if fn  (close fn))
    (if bat (close bat))
    (if dat (close dat))
    (setq *error* old_err)

    (princ)
);ms_err

;*****************************************************************************
(prompt ".")
;********************* HILFEFUNKTION ******************************************
; Parameter: keine
; Rckgabe : keine

(defun c:mshilfe ()
    (msbv_setvar)
    (newerr "c:tshilfe")
    (ms_help)
    (rest_setvar)
    (olderr)
    (princ)
)

;*****************************************************************************
(prompt ".")
;********************* ICON DISABLEN *****************************************
(defun icon_disable( / n i x y dia)
    (newerr "icon_disable > tric")
    (setq n 0)
    (repeat 12
        (if (< n 10)
		 (progn
            (setq i (strcat "0" (itoa n)))
        )(progn
            (setq i (itoa n))
        ))
        (setq dia (strcat "icon" i))
        (setq x   (dimx_tile dia))
        (setq y   (dimy_tile dia))
        (setq txt (strcat "text" i))
        (setq tx  (dimx_tile txt))
        (setq ty  (dimy_tile txt))
        (start_image dia)
        (fill_image 0 0 x y -2)
        (end_image)
        (start_image txt)
        (fill_image 0 0 tx ty -2)
        (end_image)

        (mode_tile dia 1)
        (set_tile (strcat "text" i) "")
        (mode_tile (strcat "text" i) 1)
        (setq n (1+ n))
    )
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* POPUP-BEFEHL ERMITTELN ********************************
(defun get_popup (pop / ret)
    (newerr "get_popup > tric")
    (setq ret (nth (atoi $value) pop))
    (olderr)
    (setq ret ret)
)

;*****************************************************************************
(prompt ".")
;********************* ANGEWHLTEN BLOCKNAMEN ERMITTELN **********************
(defun get_block (var / ret)
    (newerr "get_block > msblockv")
    (setq ret (strcat bvins_dir "\\" gewerk "\\" group "\\" page
                      "\\" (setq pick_block (nth (atoi (substr var 5)) bl_nam_dos))))
    (olderr)
    (setq ret ret)
)

;*****************************************************************************
(prompt ".")
;********************* SEITEN ZUM GEWERK ANZEIGEN ****************************

(defun show_gewerk (var / n l_liste)

    (newerr "show_gewerk > msblockv")

    ;; Mark selected Library in list
    (if (nth (atoi var) gewerk_dir)
	 (progn
        (setq gewerk (nth (atoi var) gewerk_dir))     ; Wenn Gruppe existiert
    )(progn
        (setq gewerk        (nth 0 gewerk_dir))       ; sonst 1. Eintrag
        (setq select_group  "0")
        (setq select_page   "0")
        (setq var           "0")
    ));if
    (set_tile "gewerk_list" var)

    (setq l_liste     (gen_liste (strcat bvins_dir "\\" gewerk "\\tsmb.dir")))
    (setq select_gewerk var)
    (setq dir_dos      (car l_liste))
    (setq dir_msbv     (cdr l_liste))
    (setq group_dir     dir_dos)
    (setq group_nam     dir_msbv)
    (setq page          nil)
    (setq first_icon    "")
    (setq last_icon     "")
    (setq block_nam     nil )

    (set_tile  "msg" "")
    (mode_tile "load_new" 1)

    (if dir_dos
	 (progn
	    (make_list "group_list" dir_msbv) ;SLIDERLISTE GRUPPE
        (show_group select_group)
        (set_tile "group_list" select_group)
    )(progn
        (set_tile  "msg"       msg)
	    (make_list "group_list" '("")) ;SLIDERLISTE GRUPPE
        (make_list "page_list" '("")) ;SLIDERLISTE SEITE
        (setq select_page "0")
        (icon_disable)
    ))
    (olderr)
)
;*****************************************************************************
(prompt ".")
;********************* SEITEN ZUR GRUPPE ANZEIGEN ****************************
(defun show_group (var / n l_liste)

    (newerr "show_group > msblockv")

    (if (nth (atoi var) group_dir)
	 (progn
        (setq group (nth (atoi var) group_dir))    ; Wenn Gruppe existiert
    )(progn
        (setq group (nth 0 group_dir))             ; sonst 1. Eintrag
        (setq select_page   "0")
        (setq var           "0")
    ));if
    (set_tile "group_list" var)

    (setq l_liste      (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\tsmb.dir")))
    (setq select_group  var)
    (setq dir_dos      (car l_liste))
    (setq dir_msbv     (cdr l_liste))
    (setq page          nil)
    (setq first_icon    "")
    (setq last_icon     "")
    (setq block_nam     nil)

    (set_tile  "msg"       "")
    (mode_tile "load_new"  1)

    (if dir_dos
	 (progn
	    (make_list "page_list" dir_msbv) ;SLIDERLISTE SEITE
        (show_page select_page)
        (set_tile "page_list" select_page)
    )(progn
	    (make_list "page_list" '("")) ;SLIDERLISTE SEITE
        (set_tile "msg" msg)
        (icon_disable)
    ))
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* BLCKE ZUR SEITE ANZEIGEN *****************************
(defun show_page (var / n i x y l_liste dia txt)

    (newerr "show_page > msblockv")
    (icon_disable)

    (if (nth (atoi var) dir_dos)
	 (progn
        (setq page (nth (atoi var) dir_dos))  ; Wenn Seite existiert
    )(progn
        (setq page (nth 0 dir_dos)            ; Sonst 1. Eintrag
              var  "0")
    ));if

    (setq l_liste     (gen_liste (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\tsmb.ins")))
    (setq bl_nam_dos  (car l_liste))
    (setq bl_nam_msbv (cdr l_liste))
    (setq select_page var)
    (setq first_icon "")
    (setq last_icon "")
    (setq block_nam nil)

    (set_tile  "msg"     "")
    (setq       n         0)
    (mode_tile "load_new" 1)

    (repeat (length bl_nam_dos)                ;TEXT ANZEIGEN u. DIA ANZEIGEN
        (if (< n 10)
		 (progn
            (setq i (strcat "0" (itoa n)))
        )(progn
            (setq i (itoa n))
        ))
        (setq dia (strcat "icon" i))
        (setq txt (strcat "text" i))
        (setq x   (dimx_tile dia))
        (setq y   (dimy_tile dia))

        (mode_tile dia 0)
		(mode_tile txt 0)       ;AKTIVIEREN
        (start_image dia)
		(fill_image  0 0 x y -2)
        (slide_image 0 0 x y (strcat bvins_dir "\\" gewerk "\\" group "\\" page "\\" (nth n bl_nam_dos)))
        (end_image)
        (set_tile txt (nth n bl_nam_msbv))
        (setq n (1+ n))
    )
    (set_tile "msg" msg)
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* LETZTE EINSTELLUNG SPEICHERN **************************
(defun cfg ( / fn)

    (newerr "cfg > msblockv")

    (if gewerk_nam
	 (progn
        ;WENN MINDESTENS 1 GEWERK EXISTIERT
        (setq fn   (open bvcfg_file "w"))
        (setq line (strcat "MERViSOFT TRICsy configuration file" (strcase bvcfg_file)))
        (write-line (C_ConvertWINtoDOS line) fn)

        ;; Bibliothek
        (while (< (strlen select_gewerk) 9)
            (setq select_gewerk (strcat select_gewerk " "))
        )
        (setq line (strcat select_gewerk (nth (atoi select_gewerk) gewerk_nam)))
        (write-line (C_ConvertWINtoDOS line) fn)

        ;; Gruppe
        (while (< (strlen select_group) 9)
            (setq select_group (strcat select_group " "))
        )
        (setq line select_group)
        (if (/= 0 (length group_nam))
		 (progn
            (setq line (strcat line (nth (atoi select_group) group_nam)))
        ))
        (write-line (C_ConvertWINtoDOS line) fn)  ;; Gruppe

        ;; Seite
        (while (< (strlen select_page) 9)
            (setq select_page (strcat select_page " "))
        )

        (if dir_msbv
		 (progn
            (setq line (strcat select_page (nth (atoi select_page) dir_msbv)))
            (write-line (C_ConvertWINtoDOS line) fn)  ;; Seite
        )(progn
            (setq line select_page)
            (write-line (C_ConvertWINtoDOS line) fn)  ;; Seite
        ))

        (while (< (strlen select_insert_mod) 9)
            (setq select_insert_mod (strcat select_insert_mod " "))
        )
        (setq line (strcat select_insert_mod (nth (atoi select_insert_mod) insert_mod)))
        (write-line (C_ConvertWINtoDOS line) fn)   ;; Insert_Mode

        (while (< (strlen select_al) 9)
            (setq select_al (strcat select_al " "))
        )
        (setq line  (itoa ins_al))
        (write-line (C_ConvertWINtoDOS line) fn)   ;; Select_al

        (setq line  (itoa ins_xref))
        (write-line (C_ConvertWINtoDOS line) fn)   ;; XRef

        (setq line  select_skal)
        (write-line (C_ConvertWINtoDOS line) fn)   ;; Select_Scale

        (setq line  select_skal_box)
        (write-line (C_ConvertWINtoDOS line) fn)   ;; Select_Scale_Box

        (setq fn (close fn))
	 )
    )
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* SPEICHER FREIGEBEN ************************************
(defun nil_msbv ()

 (newerr "nil_msbv > msblockv")

 (setq bvprog_dir nil dir_msbv nil dir_dos nil mk_dir nil fn nil lastpick nil
       bl_nam_msbv nil bl_nam_dos nil bvins_dir nil gewerk nil group nil page nil
       select_group nil select_page nil gewerk_nam nil group_nam nil gewerk_dir nil group_dir nil
       o_cmdecho nil o_attreq nil o_expert nil select_insert_def nil
       bvdcl_file nil bvgrp_file nil bvhelp_file nil bvcfg_file nil zeile nil
       l_liste nil gewerk_pop nil group_pop nil insert_def nil insert_mod nil pick_block nil
       block_nam nil ins_al nil select_insert_def nil select_insert_mod nil
       select_al nil first_icon nil last_icon nil c nil bat nil errpoint nil
       o_errpoint nil
 )
)

;*****************************************************************************
(prompt ".")
;*****************************************************************************

(msbv_setvar)
(rest_setvar)

(setvar "cmdecho" 1)
(princ)
